class ProxyGroup {
  final String name;
  final String type;
  final List<String> proxies;

  ProxyGroup({
    required this.name,
    required this.type,
    required this.proxies,
  });

  factory ProxyGroup.fromMap(Map<String, dynamic> map) {
    return ProxyGroup(
      name: map['name'],
      type: map['type'],
      proxies: List<String>.from(map['proxies']),
    );
  }

  Map<String, dynamic> toJson() {
    return {
      'name': name,
      'type': type,
      'proxies': proxies,
    };
  }

  String toYaml() {
    var proxiesYaml = proxies.map((p) => '      - $p').join('\n');
    return '''
  - name: $name
    type: $type
    proxies:
$proxiesYaml
''';
  }

}
