
import 'dart:io';

import 'wl_base_help_platform_interface.dart';

class WlBaseHelp {
  Future<String?> getPlatformVersion() {
    return WlBaseHelpPlatform.instance.getPlatformVersion();
  }

  Future<String?> runAsAdministrator() {
    return WlBaseHelpPlatform.instance.runAsAdministrator();
  }

  Future<bool?> isRunningAsAdmin() {
    if(Platform.isMacOS) {
      return WlBaseHelpPlatform.instance.macIsAdmin();
    }
    return WlBaseHelpPlatform.instance.isRunningAsAdmin();
  }

  Future<void> showConsole() async {
    await WlBaseHelpPlatform.instance.showConsole();
  }

  Future<void> hideConsole() async {
    await  WlBaseHelpPlatform.instance.hideConsole();
  }

  Future<bool?> isProcessRunning(String processName){
    if(Platform.isMacOS) {
      return WlBaseHelpPlatform.instance.macIsProcessRunning();
    }
    return WlBaseHelpPlatform.instance.isProcessRunning(processName);
  }

  Future<void> killProcess(String processName)  async {
    await  WlBaseHelpPlatform.instance.killProcess(processName);
  }

  // 新增：启用代理
  Future<void> startProxy(int port) async {
    await WlBaseHelpPlatform.instance.startProxy(port);
  }

  // 新增：禁用代理
  Future<void> stopProxy() async {
    await WlBaseHelpPlatform.instance.stopProxy();
  }

  // 新增：检测代理是否启用
  Future<bool> isProxyEnabled() async {
    return WlBaseHelpPlatform.instance.isProxyEnabled();
  }

  Future<bool> isDialUpEnabled() async {
    return WlBaseHelpPlatform.instance.isDialUpEnabled();
  }
}
