import 'package:flutter_test/flutter_test.dart';
import 'package:wl_base_help/wl_base_help.dart';
import 'package:wl_base_help/wl_base_help_platform_interface.dart';
import 'package:wl_base_help/wl_base_help_method_channel.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

class MockWlBaseHelpPlatform
    with MockPlatformInterfaceMixin
    implements WlBaseHelpPlatform {

  @override
  Future<String?> getPlatformVersion() => Future.value('42');

  @override
  Future<String?> runAsAdministrator() {
    // TODO: implement runAsAdministrator
    throw UnimplementedError();
  }

  @override
  Future<bool?> isRunningAsAdmin() {
    // TODO: implement isRunningAsAdmin
    throw UnimplementedError();
  }

  @override
  Future<void> hideConsole() {
    // TODO: implement hideConsole
    throw UnimplementedError();
  }

  @override
  Future<void> showConsole() {
    // TODO: implement showConsole
    throw UnimplementedError();
  }

  @override
  Future<bool?> isProcessRunning(String processName) {
    // TODO: implement isProcessRunning
    throw UnimplementedError();
  }

  @override
  Future<void> killProcess(String processName) {
    // TODO: implement killProcess
    throw UnimplementedError();
  }

  @override
  Future<bool?> macIsAdmin() {
    // TODO: implement macIsAdmin
    throw UnimplementedError();
  }

  @override
  Future<bool?> macIsProcessRunning() {
    // TODO: implement macisProcessRunning
    throw UnimplementedError();
  }
}

void main() {
  final WlBaseHelpPlatform initialPlatform = WlBaseHelpPlatform.instance;

  test('$MethodChannelWlBaseHelp is the default instance', () {
    expect(initialPlatform, isInstanceOf<MethodChannelWlBaseHelp>());
  });

  test('getPlatformVersion', () async {
    WlBaseHelp wlBaseHelpPlugin = WlBaseHelp();
    MockWlBaseHelpPlatform fakePlatform = MockWlBaseHelpPlatform();
    WlBaseHelpPlatform.instance = fakePlatform;

    expect(await wlBaseHelpPlugin.getPlatformVersion(), '42');
  });
}
