#ifndef FLUTTER_PLUGIN_WL_BASE_HELP_PLUGIN_H_
#define FLUTTER_PLUGIN_WL_BASE_HELP_PLUGIN_H_

#include <flutter/method_channel.h>
#include <flutter/plugin_registrar_windows.h>

#include <memory>

namespace wl_base_help {

class WlBaseHelpPlugin : public flutter::Plugin {
 public:
    HWND windowHwnd;

    HWND GetMainWindow();
    bool IsRunningAsAdmin();
    void TryRunAsAdmin(HWND hwnd,std::unique_ptr<flutter::MethodResult<flutter::EncodableValue>>& result);

    static void RegisterWithRegistrar(flutter::PluginRegistrarWindows *registrar);

  WlBaseHelpPlugin(flutter::PluginRegistrarWindows* registrar);

  virtual ~WlBaseHelpPlugin();

  // Disallow copy and assign.
  WlBaseHelpPlugin(const WlBaseHelpPlugin&) = delete;
  WlBaseHelpPlugin& operator=(const WlBaseHelpPlugin&) = delete;

  // Called when a method is called on this plugin's channel from Dart.
  void HandleMethodCall(
      const flutter::MethodCall<flutter::EncodableValue> &method_call,
      std::unique_ptr<flutter::MethodResult<flutter::EncodableValue>> result);

private:
    flutter::PluginRegistrarWindows* registrar;
};

}  // namespace wl_base_help

#endif  // FLUTTER_PLUGIN_WL_BASE_HELP_PLUGIN_H_
